/**
 * JSON Web Token (JWT) classes.
 *
 * <p>This package provides representation, compact serialisation and parsing 
 * for the following JWT objects:
 *
 * <ul>
 *     <li>{@link com.nimbusds.jwt.PlainJWT Unsecured (plain) JWTs}.
 *     <li>{@link com.nimbusds.jwt.SignedJWT Signed JWTs}.
 *     <li>{@link com.nimbusds.jwt.EncryptedJWT Encrypted JWTs}.
 * </ul>
 *
 * <p>References:
 *
 * <ul>
 *     <li>RFC 7519 (JWT)
 * </ul>
 */
package com.nimbusds.jwt;
